DynamicRoutine:

	LDA !FramePointer
	ASL
	TAY ;transfer the current frame to Y

	PHB
	PLA
	STA $02 ;set the BNK of the graphics
	STZ $03

	REP #$20
	LDA VramTable,y
	CMP #$FFFF
	BNE +
	SEP #$20
	RTS
+	
	CLC
	ADC GFXPointer ;get the graphic pointer to the current frame
	STA $00
	SEP #$20
	
	JSL getslot ;calls the getslot routine
	
	LDA !extraBit
	AND #$04
	LSR
	LSR
	TAY ;put the extra bit on Y
	
	LDA !mode50
	BEQ	+
	INY
	INY ;if mode 50 then y = y+2
+	
	LDA $0F
	CMP #$FF
	BEQ + ;if all slot are occupate dont update
	CLC
	ADC adder,y
	STA !tilesRelativePosition ;set the relative tile position
	
	LDA !invisible
	BEQ +
	DEC A
	STA !invisible ;DEC invisible if non zero
+
	RTS
	
adder: db $00,$40,$C0,$20
	
GFXPointer:
dw resource

;fill this with the name of your exgfx (replace "resource.bin" for the name of your graphic.bin)
resource:
incbin sprites\gfx1.bin

